using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using UnityEngine;

public class ClassBase {

  [HideInInspector] public int MaxHealth;
  [HideInInspector] public int MaxMana;
  [HideInInspector] public float AttackPower;
  [HideInInspector] public float MagicPower;
  //[HideInInspector] public List<Ability> Abilities;

  protected Player Player;
  protected Animator Animator;
  protected AttackAnimatorFactory AttackAnimator;
  protected float PlayerOriginalSpeed;
  protected FloatingTextSpawner TextPopUp;
  /// <summary>Always in the order of Up, Down, Left, Right</summary>
  public string AnimationToPlay;

  public ClassBase(Player player) {
    Player = player;
    Animator = Player.Animator;
    AttackAnimator = Player.AttackAnimator;
    TextPopUp = new FloatingTextSpawner(player.transform);
  }

  virtual public void Tick() { }
  virtual public void HandleLMB() { }
  virtual public void HandleRMB() { }
}
